searchNodes=[{"doc":"ResourceAdmin modules should be created for every schema you want to customize/configure in Kaffy. If you have a schema like MyApp.Products.Product, you should create an admin module with name MyApp.Products.ProductAdmin and add functions documented in this module to customize the behavior. All functions are optional.","ref":"Kaffy.ResourceAdmin.html","title":"Kaffy.ResourceAdmin","type":"module"},{"doc":"authorized?/2 takes the schema and the current Plug.Conn struct and should return a boolean value. Returning false will prevent the access of this resource for the current user/request. If authorized?/2 is not defined, Kaffy will return true. Example: def authorized?(_schema, _conn) do true end","ref":"Kaffy.ResourceAdmin.html#authorized?/2","title":"Kaffy.ResourceAdmin.authorized?/2","type":"function"},{"doc":"create_changeset/2 takes the record and the changes and should return a changeset for creating a new record. If create_changeset/2 is not defined, Kaffy will try to call schema.changeset/2 and if that&#39;s not defined, Ecto.Changeset.change/2 will be called. Example: def create_changeset(schema, attrs) do MyApp.Blog.Post.create_changeset(schema, attrs) end","ref":"Kaffy.ResourceAdmin.html#create_changeset/2","title":"Kaffy.ResourceAdmin.create_changeset/2","type":"function"},{"doc":"form_fields/1 takes a schema and returns a keyword list of fields and their options for the new/edit form. Supported options are: :label, :type, :choices, and :permission :type can be any ecto type in addition to :file and :textarea If :choices is provided, it must be a keyword list and the field will be rendered as a &lt;select&gt; element regardless of the actual field type. Setting :permission to :read will make the field non-editable. It is :write by default. If you want to remove a field from being rendered, just remove it from the list. If form_fields/1 is not defined, Kaffy will return all the fields with their default types based on the schema. Example: def form_fields(_schema) do [ title: %{label: &quot;Subject&quot;}, slug: nil, image: %{type: :file}, status: %{choices: [{&quot;Pending&quot;, &quot;pending&quot;}, {&quot;Published&quot;, &quot;published&quot;}]}, body: %{type: :textarea, rows: 3}, views: %{permission: :read} ] end","ref":"Kaffy.ResourceAdmin.html#form_fields/1","title":"Kaffy.ResourceAdmin.form_fields/1","type":"function"},{"doc":"index/1 takes the schema module and should return a keyword list of fields and their options. Supported options are :name and :value. Both options can be a string or an anonymous function. If a fuction is provided, the current entry is passed to it. If index/1 is not defined, Kaffy will return all the fields of the schema and their default values. Example: def index(_schema) do [ id: %{name: &quot;ID&quot;, value: fn post -&gt; post.id + 100 end}, title: nil, # this will render the default name for this field (Title) and its default value (post.title) views: %{name: &quot;Hits&quot;, value: fn post -&gt; post.views + 10 end}, published: %{name: &quot;Published?&quot;, value: fn post -&gt; published?(post) end}, comment_count: %{name: &quot;Comments&quot;, value: fn post -&gt; comment_count(post) end} ] end","ref":"Kaffy.ResourceAdmin.html#index/1","title":"Kaffy.ResourceAdmin.index/1","type":"function"},{"doc":"ordering/1 takes a schema and returns how the entries should be ordered. If ordering/1 is not defined, Kaffy will return [desc: :id]. Example: def ordering(_schema) do [asc: :title] end","ref":"Kaffy.ResourceAdmin.html#ordering/1","title":"Kaffy.ResourceAdmin.ordering/1","type":"function"},{"doc":"This is useful for names that cannot be plural by adding an &quot;s&quot; at the end. Like &quot;Category&quot; =&gt; &quot;Categories&quot; or &quot;Person&quot; =&gt; &quot;People&quot;. If plural_name/1 is not defined, Kaffy will use the singular name and add an &quot;s&quot; to it (e.g. Posts). Example: def plural_name(_schema) do &quot;Categories&quot; end","ref":"Kaffy.ResourceAdmin.html#plural_name/1","title":"Kaffy.ResourceAdmin.plural_name/1","type":"function"},{"doc":"","ref":"Kaffy.ResourceAdmin.html#resource_actions/2","title":"Kaffy.ResourceAdmin.resource_actions/2","type":"function"},{"doc":"search_fields/1 takes a schema and must return a list of :string fields to search against when typing in the search box. If search_fields/1 is not defined, Kaffy will return all the :string fields of the schema. Example: def search_fields(_schema) do [:title, :slug, :body] end","ref":"Kaffy.ResourceAdmin.html#search_fields/1","title":"Kaffy.ResourceAdmin.search_fields/1","type":"function"},{"doc":"This function should return a string for the singular name of a resource. If singular_name/1 is not defined, Kaffy will use the name of the last part of the schema module (e.g. Post in MyApp.Blog.Post) This is useful for when you have a schema but you want to display its name differently. If you have &quot;Post&quot; and you want to display &quot;Article&quot; for example. Example: def singular_name(_schema) do &quot;Article&quot; end","ref":"Kaffy.ResourceAdmin.html#singular_name/1","title":"Kaffy.ResourceAdmin.singular_name/1","type":"function"},{"doc":"update_changeset/2 takes the record and the changes and should return a changeset for updating an existing record. If update_changeset/2 is not defined, Kaffy will try to call schema.changeset/2 and if that&#39;s not defined, Ecto.Changeset.change/2 will be called. Example: def update_changeset(schema, attrs) do MyApp.Blog.Post.create_changeset(schema, attrs) end","ref":"Kaffy.ResourceAdmin.html#update_changeset/3","title":"Kaffy.ResourceAdmin.update_changeset/3","type":"function"},{"doc":"Kaffy.Routes must be &quot;used&quot; in your phoenix routes: use Kaffy.Routes, scope: &quot;/admin&quot;, pipe_through: [:browser, :authenticate] :scope defaults to &quot;/admin&quot; :pipe_through defaults to kaffy&#39;s [:kaffy_browser]","ref":"Kaffy.Routes.html","title":"Kaffy.Routes","type":"module"},{"doc":"Kaffy Extremely simple yet powerful admin interface for phoenix applications","ref":"readme.html","title":"Kaffy","type":"extras"},{"doc":"Check out the simple demo here","ref":"readme.html#demo","title":"Kaffy - Demo","type":"extras"},{"doc":"elixir 1.7.0 phoenix 1.4.0","ref":"readme.html#minimum-requirements","title":"Kaffy - Minimum Requirements","type":"extras"},{"doc":"Add kaffy as a dependency def deps do [ {:kaffy, &quot;~&gt; 0.4.0&quot;} ] end These are the minimum configurations required # in your router.ex use Kaffy.Routes, scope: &quot;/admin&quot;, pipe_through: [:some_plug, :authenticate] # :scope defaults to &quot;/admin&quot; # :pipe_through defaults to kaffy&#39;s [:kaffy_browser] # in your endpoint.ex plug Plug.Static, at: &quot;/kaffy&quot;, from: :kaffy, gzip: false, only: ~w(css img js scss vendor) # in your config/config.exs config :kaffy, otp_app: :my_app, ecto_repo: Bloggy.Repo, router: BloggyWeb.Router","ref":"readme.html#installation","title":"Kaffy - Installation","type":"extras"},{"doc":"","ref":"readme.html#what-you-get","title":"Kaffy - What You Get","type":"extras"},{"doc":"Configurations If you don&#39;t specify a resources option in your configs, Kaffy will try to auto-detect your schemas and your admin modules. Admin modules should be in the same namespace as their respective schemas in order for kaffy to detect them. For exmaple, if you have a schema MyApp.Products.Product, its admin module should be MyApp.Products.ProductAdmin. Otherwise, if you&#39;d like to explicitly specify your schemas and their admin modules, you can do like the following: # config.exs config :kaffy, admin_title: &quot;My Awesome App&quot;, ecto_repo: MyApp.Repo, router: MyAppWeb.Router, resources: [ blog: [ name: &quot;My Blog&quot;, # a custom name for this context/section. schemas: [ post: [schema: MyApp.Blog.Post, admin: MyApp.SomeModule.Anywhere.PostAdmin], comment: [schema: MyApp.Blog.Comment], tag: [schema: MyApp.Blog.Tag] ] ], inventory: [ name: &quot;Inventory&quot;, schemas: [ category: [schema: MyApp.Products.Category, admin: MyApp.Products.CategoryAdmin], product: [schema: MyApp.Products.Product, admin: MyApp.Products.ProductAdmin] ] ] ] Note that, for auto-detection to work properly, schemas in different contexts should have different direct &quot;prefix&quot; namespaces. That is: # auto-detection works properly with this: MyApp.Posts.Post MyApp.Posts.Category MyApp.Products.Product MyApp.Products.Category # this Category will not be confused with Posts.Category # auto-detection will be confused with this: # both Category schemas have the same &quot;Schemas&quot; prefix. MyApp.Posts.Schemas.Post MyApp.Posts.Schemas.Category MyApp.Products.Schemas.Product MyApp.Products.Schemas.Category # To fix this, define resources manually: resources: [ posts: [ schemas: [ post: [schema: MyApp.Posts.Schemas.Post], category: [schema: MyApp.Posts.Schemas.Category] ] ], products: [ schemas: [ product: [schema: MyApp.Products.Schemas.Product], category: [schema: MyApp.Products.Schemas.Category] ] ] ] Index page The index/1 function takes a schema and must return a keyword list of fields and their options. If the options are nil, Kaffy will use default values for that field. If this function is not defined, Kaffy will return all fields with their respective values. defmodule MyApp.Blog.PostAdmin do def index(_) do [ title: nil, views: %{name: &quot;Hits&quot;}, date: %{name: &quot;Date Added&quot;, value: fn p -&gt; p.inserted_at end}, good: %{name: &quot;Popular?&quot;, value: fn _ -&gt; Enum.random([&quot;Yes&quot;, &quot;No&quot;]) end} ] end end Result Notice that the keyword list keys don&#39;t necessarily have to be schema fields as long as you provide a :value option. You can also provide some basic column-based filtration by providing the :filters option: defmodule MyApp.Products.ProductAdmin do def index(_) do [ title: nil, category_id: %{ value: fn p -&gt; get_category!(p.category_id).name end, filters: Enum.map(list_categories(), fn c -&gt; {c.name, c.id} end) }, price: %{value: fn p -&gt; Decimal.to_string(p.price) end}, quantity: nil, status: %{ name: &quot;Is it available?&quot;, value: fn p -&gt; available?(p) end, filters: [{&quot;Available&quot;, &quot;available&quot;}, {&quot;Sold out&quot;, &quot;soldout&quot;}] }, views: nil ] end end :filters must be a list of tuples where the first element is a human-frieldy string and the second element is the actual field value used to filter the records. Result If you need to change the order of the records, define ordering/1: defmodule MyApp.Blog.PostAdmin do def ordering(_schema) do # order posts based on views [desc: :views] end end Show/edit page Kaffy treats the show and edit pages as one. To customize the fields shown in this page, define a form_fields/1 function in your admin module. defmodule MyApp.Blog.PostAdmin do def form_fields(_) do [ title: nil, status: %{choices: [{&quot;Publish&quot;, &quot;publish&quot;}, {&quot;Pending&quot;, &quot;pending&quot;}]}, body: %{type: :textarea, rows: 4}, views: %{permission: :read}, settings: %{label: &quot;Post Settings&quot;} ] end end The form_fields/1 function takes a schema and should return a keyword list of fields and their options. The keys of the list must correspond to the schema fields. Options can be: :label - must be a string. :type - can be any ecto type in addition to :file and :textarea. :rows - an integer to indicate the number of rows for textarea fields. :choices - a keyword list of option and values to restrict the input values that this field can accept. :permission - can be either :write (field is editable) or :read (field is non-editable). It is :write by default. Result Notice that: Even though the status field is of type :string, it is rendered as a &lt;select&gt; element with choices. The views field is rendered as &quot;readonly&quot; because it has the :read permission. settigns is an embedded schema. That&#39;s why it is rendered as such. Search and filtration Kaffy provides very basic search capabilities. Currently, only :string and :text fields are supported for search. If you need to customize the list of fields to search against, define the search_fields/1 function. defmodule MyApp.Blog.PostAdmin do def search_fields(_schema) do [:title, :slug, :body] end end This function takes a schema and returns a list of schema fields that you want to search. All the fields must be of type :string or :text. If this function is not defined, Kaffy will return all :string and :text fields by default. Result Authorization Kaffy supports basic authorization for individual schemas by defining authorized?/2. defmodule MyApp.Blog.PostAdmin do def authorized?(_schema, conn) do MyApp.Blog.can_see_posts?(conn.assigns.user) end end authorized?/2 takes a schema and a Plug.Conn struct and should return a boolean value. If it returns false, the request is redirected to the dashboard with an unauthorized message. Note that the resource is also removed from the resources list if authorized?/2 returns false. Result Changesets Kaffy supports separate changesets for creating and updating schemas. Just define create_changeset/2 and update_changeset/2. Both of them are passed the schema and the attributes. defmodule MyApp.Blog.PostAdmin do def create_changeset(schema, attrs) do # do whatever you want, must return a changeset MyApp.Blog.Post.my_customized_changeset(schema, attrs) end def update_changeset(entry, attrs) do # do whatever you want, must return a changeset MyApp.Blog.Post.update_changeset(entry, attrs) end end If either function is not defined, Kaffy will try calling Post.changeset/2. And if that is not defined, Ecto.Changeset.change/2 will be called. Singular vs Plural Some names do not follow the &quot;add an s&quot; rule. Sometimes you just need to change some terms to your liking. This is why singular_name/1 and plural_name/1 are there. defmodule MyApp.Blog.PostAdmin do def singular_name(_) do &quot;Article&quot; end def plural_name(_) do &quot;Terms&quot; end end Result Notice the &quot;Posts&quot; above the &quot;Terms&quot;. This is the context name and it can be changed in the configs.exs file. See the &quot;Configurations&quot; section above. Custom Actions Kaffy supports performing custom actions on single resources by defining the resource_actions/1 function. defmodule MyApp.Blog.ProductAdmin def resource_actions(_conn) do [ publish: %{name: &quot;Publish this product&quot;, action: fn _c, p -&gt; restock(p) end}, soldout: %{name: &quot;Sold out!&quot;, action: fn _c, p -&gt; soldout(p) end} ] end defp restock(product) do update_product(product, %{&quot;status&quot; =&gt; &quot;available&quot;}) end defp soldout(product) do case product.id == 3 do true -&gt; {:error, product, &quot;This product should never be sold out!&quot;} false -&gt; update_product(product, %{&quot;status&quot; =&gt; &quot;soldout&quot;}) end end Result resource_actions/1 takes a conn and must return a keyword list. The keys must be atoms defining the unqiue action &quot;keys&quot;. The values are maps providing a human-friendly :name and an :action that is an anonymous function with arity 2 that takes a conn and the record. Actions must return one of the following: {:ok, record} indicating the action was performed successfully. {:error, changeset} indicating there was a validation error. {:error, record, custom_error} to communicate a custom error message to the user where custom_error is a string. Callbacks Sometimes you need to execute certain actions when creating, updating, or deleting records. Kaffy has your back. There are a few callbacks that are called every time you create, update, or delete a record. These callbacks are: before_create/2 before_update/2 before_delete/2 before_save/2 after_save/2 after_delete/2 after_update/2 after_create/2 before_* functions are passed the current conn and a changeset. after_* functions are passed the current conn and the record itself. With the exception of before_delete/2 and after_delete/2 which are both passed the current conn and the record itself. before_(create|save|update)/2 must return {:ok, changeset} to continue. before_delete/2 must return {:ok, record} to continue. All after_* functions must return {:ok, record} to continue. To prevent the chain from continuing and roll back any changes: before_(create|save|update)/2 must return {:error, changeset}. before_delete/2 must return {:error, record, &quot;Customized error message}. All after_* functions must return {:error, record, &quot;Customized error message&quot;}. When creating a new record, the following functions are called in this order: before_create/2 before_save/2 inserting the record happens here: Repo.insert/1 after_save/2 after_create/2 When updating an existing record, the following functions are called in this order: before_update/2 before_save/2 updating the record happens here: Repo.update/1 after_save/2 after_update/2 When deleting a record, the following functions are called in this order: before_delete/2 deleting the record happens here: Repo.delete/1 after_delete/2 It&#39;s important to know that all callbacks are run inside a transaction. So in case of failure, everything is rolled back even if the operation actually happened. defmodule MyApp.Blog.PostAdmin do def before_create(conn, changeset) do case conn.assigns.user.username == &quot;aesmail&quot; do true -&gt; {:error, changeset} # aesmail should never create a post false -&gt; {:ok, changeset} end end def after_create(_conn, post) do {:error, post, &quot;This will prevent posts from being created&quot;} end def before_delete(conn, post) do case conn.assigns.user.role do &quot;admin&quot; -&gt; {:ok, post} _ -&gt; {:error, post, &quot;Only admins can delete posts&quot;} end end end Result Random features If you have a schema with a belongs_to association and this association has too many records to be included in a &lt;select&gt; box, Kaffy will automatically change the field from a &lt;select&gt; box to a text box and opens a new where the association records are paginated and filterable so you can select the necessary record with ease.","ref":"readme.html#customizations","title":"Kaffy - Customizations","type":"extras"},{"doc":"Kaffy was created out of a need to have a minimum, flexible, and customizable admin interface without the need to touch the current codebase. It should work out of the box just by adding some configs in your config.exs file (with the exception of adding a one liner to your router.ex file). A few points that encouraged the creation of Kaffy: Taking contexts into account. Supporting contexts makes the admin interface better organized. Can handle as many schemas as necessary. Whether we have 1 schema or 1000 schemas, the admin interface should adapt well. Have a visually pleasant user interface. This might be subjective. No generators or generated templates. I believe the less files there are the better. This also means it&#39;s easier to upgrade for users when releasing new versions. This might mean some flexibility and customizations will be lost, but it&#39;s a trade-off. Existing schemas/contexts shouldn&#39;t have to be modified. I shouldn&#39;t have to change my code in order to adapt to the package, the package should adapt to my code. Should be easy to use whether with a new project or with existing projects with a lot of schemas. Adding kaffy should be as easy for existing projects as it is for new ones. Highly flexible and customizable. Provide as many configurable options as possible. As few dependencies as possible. Currently kaffy only depends on phoenix and ecto. Simple authorization. I need to limit access for some admins to some schemas. Minimum assumptions. Need to modify a schema&#39;s primary key? Need to hide a certain field? No problem.","ref":"readme.html#why-another-admin-interface","title":"Kaffy - Why another admin interface","type":"extras"}]